using UnityEngine;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {

          // register item to the mod registry
          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Homeless Harry",
                  DescriptionOverride = "Dangerous Harry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Homeless-Harry-thumb.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var skin = ModAPI.LoadTexture("Sprites/Homeless-Harry-skin.png");
                      var flesh = ModAPI.LoadTexture("Sprites/Homeless-Harry-flesh.png");
                      var bone = ModAPI.LoadTexture("Sprites/Homeless-Harry-bone.png");
                      var person = Instance.GetComponent<PersonBehaviour>();
                      person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                            }
                        );
                        ModAPI.Register(
                            new Modification()
                            {
                                OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                                NameOverride = "Harry Pistol",
                                NameToOrderByOverride = "!",
                                DescriptionOverride = "",
                                CategoryOverride = ModAPI.FindCategory("Firearms"),
                                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Harry-Pistol-thumb.png"),
                                AfterSpawn = (Instance) =>
                                {
                                    ModAPI.KeepExtraObjects();

                                    var ColtSlide = Instance.transform.Find("Slide");
                                    ColtSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Harry-Pistol-slide.png");

                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/Harry-pistol-col.png", 10);
                                    foreach (var c in Instance.GetComponents<Collider2D>())
                                    {
                                        GameObject.Destroy(c);
            						}
                                    Instance.FixColliders();
                                    Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                    {
                                        ModAPI.LoadSprite("Sprites/Harry-Pistol.png"),
                                    };

                                    var firearm = Instance.GetComponent<FirearmBehaviour>();
                                    firearm.BulletsPerShot = 1;
                                    firearm.ShotSounds = new AudioClip[]
                                    {
                                          ModAPI.LoadSound("Sounds/Harry-Pistol.mp3"),
                                    };

                                    Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                                    customCartridge.name = "Harry-Pistol";
                                    customCartridge.Damage = 9f;
                                    customCartridge.Recoil = 0.2f;
                                    customCartridge.ImpactForce = 0.1f;
                                    firearm.Cartridge = customCartridge;
                                  }
                                          }
                                      );
                                  }
                              }
                          }
